package dao

import (
	"github.com/shopspring/decimal"
	"server/global"
)

type Collection struct {
	global.GVA_MODEL
	ProjectCode string          `json:"projectCode" from:"projectCode" gorm:"comment:项目编码"`
	Price       decimal.Decimal `json:"price" from:"price" gorm:"type:decimal(10,2);not null;comment:收款金额"`
	Time        string          `json:"time" from:"time" gorm:"comment:收款日期;type:datetime"`
}

func (Collection) TableName() string {
	return "collection"
}

// TODO:收款查询

// QueryCollection 查询收款
func QueryCollection(code string) (collection []Collection, err error) {
	err = global.GVA_DB.Model(&Collection{}).Where("project_code = ?", code).Find(&collection).Error
	return collection, err
}

// TODO:收款新增

// CreateCollection 新增收款
func (c Collection) CreateCollection() error {
	return global.GVA_DB.Create(&c).Error
}

// TODO:收款修改

// UpdateCollection 修改收款
func (c Collection) UpdateCollection() error {
	return global.GVA_DB.Model(&c).Updates(&c).Error
}

// TODO:收款删除

// DeleteCollection 删除收款
func (c Collection) DeleteCollection() error {
	return global.GVA_DB.Unscoped().Delete(&c).Error
}
